diff --git a/Novetus/NovetusLauncher/Forms/LauncherForm/LauncherFormShared.cs b/Novetus/NovetusLauncher/Forms/LauncherForm/LauncherFormShared.cs
index d2343ab..d2f7a3e 100644
--- a/Novetus/NovetusLauncher/Forms/LauncherForm/LauncherFormShared.cs
+++ b/Novetus/NovetusLauncher/Forms/LauncherForm/LauncherFormShared.cs
@@ -586,6 +586,7 @@ namespace NovetusLauncher
             PlayerLimitBox.Value = Convert.ToDecimal(GlobalVars.UserConfiguration.ReadSettingInt("PlayerLimit"));
             PlayerNameTextBox.Text = GlobalVars.UserConfiguration.ReadSetting("PlayerName");
             SelectedClientLabel.Text = GlobalVars.UserConfiguration.ReadSetting("SelectedClient");
+            ChangeClient();
             SelectedMapLabel.Text = GlobalVars.UserConfiguration.ReadSetting("Map");
             Tree.SelectedNode = TreeNodeHelper.SearchTreeView(GlobalVars.UserConfiguration.ReadSetting("Map"), Tree.Nodes);
             Tree.Focus();
diff --git a/Novetus/NovetusLauncher/Forms/LauncherForm/Stylish/LauncherFormStylish.cs b/Novetus/NovetusLauncher/Forms/LauncherForm/Stylish/LauncherFormStylish.cs
index 2f4d8f2..aa626a4 100644
--- a/Novetus/NovetusLauncher/Forms/LauncherForm/Stylish/LauncherFormStylish.cs
+++ b/Novetus/NovetusLauncher/Forms/LauncherForm/Stylish/LauncherFormStylish.cs
@@ -110,6 +110,7 @@ namespace NovetusLauncher
             launcherFormStylishInterface1.tripcodeLabel.Content = GlobalVars.PlayerTripcode.ToString();
             launcherFormStylishInterface1.maxPlayersBox.Text = GlobalVars.UserConfiguration.ReadSetting("PlayerLimit");
             launcherFormStylishInterface1.userNameBox.Text = GlobalVars.UserConfiguration.ReadSetting("PlayerName");
+            launcherFormStylishInterface1.ChangeClient();
             launcherFormStylishInterface1.mapsBox.SelectedNode = TreeNodeHelper.SearchTreeView(GlobalVars.UserConfiguration.ReadSetting("Map"), launcherFormStylishInterface1.mapsBox.Nodes);
             launcherFormStylishInterface1.mapsBox.Focus();
             //stupid fucking HACK because we aren't selecting it properly.
diff --git a/Novetus/NovetusLauncher/Forms/LauncherForm/Stylish/LauncherFormStylishInterface.xaml.cs b/Novetus/NovetusLauncher/Forms/LauncherForm/Stylish/LauncherFormStylishInterface.xaml.cs
index c8b2548..1b0ce19 100644
--- a/Novetus/NovetusLauncher/Forms/LauncherForm/Stylish/LauncherFormStylishInterface.xaml.cs
+++ b/Novetus/NovetusLauncher/Forms/LauncherForm/Stylish/LauncherFormStylishInterface.xaml.cs
@@ -5,6 +5,7 @@ using System.Collections.Generic;
 using System.IO;
 using System.Windows;
 using System.Windows.Controls;
+using System.Windows.Controls.Primitives;
 using System.Windows.Forms;
 using System.Windows.Input;
 #endregion
@@ -144,6 +145,11 @@ namespace NovetusLauncher
         }
 
         private void clientListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
+        {
+            ChangeClient();
+        }
+
+        public void ChangeClient()
         {
             if (!IsLoaded)
                 return;
diff --git a/defaultaddons/ShadersCompatibility.lua b/defaultaddons/ShadersCompatibility.lua
index b882202..d1b20ec 100644
--- a/defaultaddons/ShadersCompatibility.lua
+++ b/defaultaddons/ShadersCompatibility.lua
@@ -42,7 +42,7 @@ function this:OnPrePlayerKicked(Player, Reason)
 		end
 	end
 
-	if (invalidSecurityVals < 3) then
+	if (invalidSecurityVals > 0) then
 		print(Player.Name .. " has "..invalidSecurityVals.." invalid security values! Verifying...")
 		validLauncher = false
 		hasTripcode = false
diff --git a/scripts/batch/github_sync.bat b/scripts/batch/github_sync.bat
index d98fdb1..51e81aa 100644
--- a/scripts/batch/github_sync.bat
+++ b/scripts/batch/github_sync.bat
@@ -169,9 +169,7 @@ XCOPY "%cd%\Novetus\misc\consolehelp.txt" "%dest%" /y
 XCOPY /c "%cd%\Novetus\.itch.toml" "%dest%" /y
 XCOPY "%cd%\Novetus\misc\masterserver\list.php" "%dest%" /y
 XCOPY "%cd%\Novetus\misc\masterserver\delist.php" "%dest%" /y
-XCOPY "%cd%\Novetus\misc\masterserver\LICENSE-MASTER-SERVER.txt" "%dest%\LICENSE-MASTER-SERVER" /y
 XCOPY "%cd%\Novetus\changelog.txt" "%dest%\changelog.txt" /y
 XCOPY "%cd%\Novetus\misc\LICENSE.txt" "%dest%\LICENSE" /y
-XCOPY "%cd%\Novetus\misc\LICENSE-RESHADE.txt" "%dest%\LICENSE-RESHADE" /y
 XCOPY "%cd%\Novetus\README-AND-CREDITS.TXT" "%dest%" /y
 if %debug%==1 pause
\ No newline at end of file
diff --git a/scripts/game/2009E/CSMPFunctions.lua b/scripts/game/2009E/CSMPFunctions.lua
index 9aa618a..a171848 100644
--- a/scripts/game/2009E/CSMPFunctions.lua
+++ b/scripts/game/2009E/CSMPFunctions.lua
@@ -22,12 +22,13 @@ function KickPlayer(Player,reason)
 	
 	if (Player ~= nil) then
 		pcall(function() _G.CSScript_OnPlayerKicked(Player,reason) end)
-
-		name = "ServerReplicator|"..Player.Name.."|"..Player.userId.."|"..Player.AnonymousIdentifier.Value
-		replicator = Server:findFirstChild(name)
-		if (replicator ~= nil) then
-			replicator:CloseConnection()
-			print("Player '" .. Player.Name .. "' Kicked. Reason: "..reason)
+	
+		for _,Child in pairs(Server:children()) do
+			name = "ServerReplicator|"..Player.Name.."|"..Player.userId.."|"..Player.AnonymousIdentifier.Value
+			if (Server:findFirstChild(name) ~= nil and Child.Name == name) then
+				Child:CloseConnection()
+				print("Player '" .. Player.Name .. "' Kicked. Reason: "..reason)
+			end
 		end
 	end
 end
@@ -61,6 +62,22 @@ function LoadCharacterNew(playerApp,newChar)
 	PlayerService = game:GetService("Players")
 	Player = PlayerService:GetPlayerFromCharacter(newChar)
 	
+	local function kick()
+		KickPlayer(Player, "Modified Client")
+	end
+	
+	if (playerApp == nil) then
+		kick()
+	end
+	
+	if (not Player:FindFirstChild("Appearance")) then
+		kick()
+	end
+	
+	if ((playerApp:GetChildren() == 0) or (playerApp:GetChildren() == nil)) then
+		kick()
+	end
+	
 	local path = "rbxasset://../../../shareddata/charcustom/"
 
 	local charparts = {[1] = newWaitForChild(newChar,"Head"),[2] = newWaitForChild(newChar,"Torso"),[3] = newWaitForChild(newChar,"Left Arm"),[4] = newWaitForChild(newChar,"Right Arm"),[5] = newWaitForChild(newChar,"Left Leg"),[6] = newWaitForChild(newChar,"Right Leg")}
@@ -459,10 +476,6 @@ function LoadSecurity(playerApp,Player,ServerSecurityLocation)
 	if (playerApp == nil) then
 		kick()
 	end
-
-	if (#playerApp:GetChildren() <= 0) then
-		kick()
-	end
 	
 	if (not Player:FindFirstChild("Security")) then
 		kick()
@@ -474,21 +487,21 @@ function LoadSecurity(playerApp,Player,ServerSecurityLocation)
 	
 	for _,newVal in pairs(playerApp:GetChildren()) do
 		if (newVal.Name == "ClientEXEMD5") then
-			if ((newVal.Value ~= ServerSecurityLocation.Security.ClientEXEMD5.Value) or (string.len(newVal.Value) ~= string.len(ServerSecurityLocation.Security.ClientEXEMD5.Value))) then
+			if (newVal.Value ~= ServerSecurityLocation.Security.ClientEXEMD5.Value or newVal.Value == "") then
 				kick()
 				break
 			end
 		end
 				
 		if (newVal.Name == "LauncherMD5") then
-			if ((newVal.Value ~= ServerSecurityLocation.Security.LauncherMD5.Value) or (string.len(newVal.Value) ~= string.len(ServerSecurityLocation.Security.LauncherMD5.Value))) then
+			if (newVal.Value ~= ServerSecurityLocation.Security.LauncherMD5.Value or newVal.Value == "") then
 				kick()
 				break
 			end
 		end
 				
 		if (newVal.Name == "ClientScriptMD5") then
-			if ((newVal.Value ~= ServerSecurityLocation.Security.ClientScriptMD5.Value) or (string.len(newVal.Value) ~= string.len(ServerSecurityLocation.Security.ClientScriptMD5.Value))) then
+			if (newVal.Value ~= ServerSecurityLocation.Security.ClientScriptMD5.Value or newVal.Value == "") then
 				kick()
 				break
 			end
@@ -530,8 +543,7 @@ function LoadTripcode(Player)
 	
 	for _,newVal in pairs(Player:GetChildren()) do
 		if (newVal.Name == "Tripcode") then
-			--56 is the length of the tripcode.
-			if ((string.len(newVal.Value) ~= 56)) then
+			if (newVal.Value == "") then
 				kick()
 				break
 			end
@@ -564,7 +576,7 @@ function CSServer(Port,PlayerLimit,ClientEXEMD5,LauncherMD5,ClientScriptMD5,Noti
 	
 	local playerCount = 0
 	PlayerService.PlayerAdded:connect(function(Player)
-		-- create anonymous player identifier. This is so we can track clients
+		-- create anonymous player identifier. This is so we can track clients without tripcodes
 		playerCount = playerCount + 1
 		
 		local code = Instance.new("StringValue", Player)
@@ -636,8 +648,6 @@ function CSServer(Port,PlayerLimit,ClientEXEMD5,LauncherMD5,ClientScriptMD5,Noti
 	coroutine.resume(coroutine.create(function()
 		while true do
 			wait(0.1)
-			game.Lighting.Security:remove()
-			InitalizeSecurityValues(game.Lighting,ClientEXEMD5,LauncherMD5,ClientScriptMD5)
 			pcall(function() _G.CSScript_Update() end)
 		end
 	end))
@@ -658,7 +668,6 @@ function CSConnect(UserID,ServerIP,ServerPort,PlayerName,Hat1ID,Hat2ID,Hat3ID,He
 	end)
 
 	local suc, err = pcall(function()
-		local playerJoined = false
 		client = game:GetService("NetworkClient")
 		player = game:GetService("Players"):CreateLocalPlayer(UserID) 
 		player:SetSuperSafeChat(false)
@@ -671,17 +680,6 @@ function CSConnect(UserID,ServerIP,ServerPort,PlayerName,Hat1ID,Hat2ID,Hat3ID,He
 		InitalizeClientAppearance(player,Hat1ID,Hat2ID,Hat3ID,HeadColorID,TorsoColorID,LeftArmColorID,RightArmColorID,LeftLegColorID,RightLegColorID,TShirtID,ShirtID,PantsID,FaceID,HeadID,ItemID)
 		InitalizeSecurityValues(player,ClientEXEMD5,LauncherMD5,ClientScriptMD5)
 		InitalizeTripcode(player,Tripcode)
-		playerJoined = true
-
-		coroutine.resume(coroutine.create(function()
-			while playerJoined do
-				wait(0.1)
-				player.Security:remove()
-				InitalizeSecurityValues(player,ClientEXEMD5,LauncherMD5,ClientScriptMD5)
-				player.Tripcode:remove()
-				InitalizeTripcode(player,Tripcode)
-			end
-		end))
 	end)
 
 	local function dieerror(errmsg)
